Index: code/branches/FICN/src/network/CMakeLists.txt
===================================================================
--- code/branches/FICN/src/network/CMakeLists.txt	(revision 440)
+++ code/branches/FICN/src/network/CMakeLists.txt	(revision 441)
@@ -1,3 +1,12 @@
 PROJECT(Orxonox)
+
+SET( CHATCLIENT_SRC_FILES
+  dummyclient3.cc
+)
+SET( CHATSERVER_SRC_FILES
+  dummyserver3.cc
+)
+
+
 
 SET( NETWORK_SRC_FILES
@@ -18,2 +27,38 @@
 ADD_LIBRARY(network SHARED ${NETWORK_SRC_FILES})
 TARGET_LINK_LIBRARIES(network ${ENet_LIBRARY} ${Boost_thread_LIBRARIES})
+
+ADD_EXECUTABLE(chatserver ${CHATSERVER_SRC_FILES})
+TARGET_LINK_LIBRARIES( chatserver
+  ${OGRE_LIBRARIES}
+  ${OIS_LIBRARIES}
+  network
+  core
+  objects
+)
+
+ADD_EXECUTABLE(chatclient ${CHATCLIENT_SRC_FILES})
+TARGET_LINK_LIBRARIES( chatclient
+  ${OGRE_LIBRARIES}
+  ${OIS_LIBRARIES}
+  network
+  core
+  objects
+)
+
+ADD_EXECUTABLE(client dummyclient2.cc)
+ADD_EXECUTABLE(server dummyserver.cc)
+TARGET_LINK_LIBRARIES( client
+  ${OGRE_LIBRARIES}
+  ${OIS_LIBRARIES}
+  network
+  core
+  objects
+)
+TARGET_LINK_LIBRARIES( server
+  ${OGRE_LIBRARIES}
+  ${OIS_LIBRARIES}
+  network
+  core
+  objects
+)
+
Index: code/branches/FICN/src/network/Makefile.test
===================================================================
--- code/branches/FICN/src/network/Makefile.test	(revision 440)
+++ code/branches/FICN/src/network/Makefile.test	(revision 441)
@@ -6,6 +6,6 @@
 
 # Link command:
-server: PacketBuffer.o ConnectionManager.o dummyserver.o PacketDecoder.o PacketGenerator.o
-	${CC} PacketDecoder.o PacketGenerator.o ConnectionManager.o dummyserver.o PacketBuffer.o -o server -lenet -lboost_thread -g
+server: PacketBuffer.o ConnectionManager.o dummyserver.o PacketDecoder.o PacketGenerator.o ClientInformation.o
+	${CC} PacketDecoder.o PacketGenerator.o ClientInformation.o ConnectionManager.o dummyserver.o PacketBuffer.o -o server -lenet -lboost_thread -g
 
 dummyserver.o: dummyserver.cc
Index: code/branches/FICN/src/network/dummyclient2.cc
===================================================================
--- code/branches/FICN/src/network/dummyclient2.cc	(revision 440)
+++ code/branches/FICN/src/network/dummyclient2.cc	(revision 441)
@@ -47,5 +47,5 @@
       std::cout << "failed sending" << std::endl;
     }
-    //usleep(100000);
+    usleep(1000000);
   }
 
Index: code/branches/FICN/src/network/dummyclient3.cc
===================================================================
--- code/branches/FICN/src/network/dummyclient3.cc	(revision 440)
+++ code/branches/FICN/src/network/dummyclient3.cc	(revision 441)
@@ -8,5 +8,5 @@
 int main(){
   network::PacketGenerator pck;
-  const int PORT = 55556
+  const int PORT = 55556;
   std::cout << "Enter address of the server xxx.xxx.xxx.xxx (enter for localhost)" << std::endl;
   std::string str;
@@ -18,11 +18,11 @@
   Client client( str, PORT );
   if ( client.establishConnection() )
-	  cout << "connection established" << endl;
-  else cout << "problems establishing connection" << endl;
+	  std::cout << "connection established" << std::endl;
+  else std::cout << "problems establishing connection" << std::endl;
   
   while (true) {
 	  client.update();
-	  cout << "your message: ";
-	  getline( cin, str );
+	  std::cout << "your message: ";
+	  std::getline( std::cin, str );
 	  client.sendChat( str );
   }
Index: code/branches/FICN/src/network/dummyserver.cc
===================================================================
--- code/branches/FICN/src/network/dummyserver.cc	(revision 440)
+++ code/branches/FICN/src/network/dummyserver.cc	(revision 441)
@@ -9,4 +9,5 @@
 #include "ConnectionManager.h"
 #include "PacketManager.h"
+#include "ClientInformation.h"
 
 #ifdef WIN32
@@ -21,7 +22,8 @@
 
 int main(){
-  ConnectionManager server = ConnectionManager();
   bool quit=false;
   ENetPacket *packet;
+  ClientInformation clients;
+  ConnectionManager server = ConnectionManager(&clients);
   server.createListener();
 
Index: code/branches/FICN/src/network/dummyserver3.cc
===================================================================
--- code/branches/FICN/src/network/dummyserver3.cc	(revision 440)
+++ code/branches/FICN/src/network/dummyserver3.cc	(revision 441)
@@ -39,10 +39,10 @@
 }
 
-int main(int argc, char *argv[]){
-  dummyserver3 server;
-  server.loop();
-  return 0;
+
 }
 
-
+int main(int argc, char **argv[]){
+  network::dummyserver3 server;
+  server.loop();
+  return 0;  
 }