Index: code/branches/objecthierarchy/src/CMakeLists.txt
===================================================================
--- code/branches/objecthierarchy/src/CMakeLists.txt	(revision 435)
+++ code/branches/objecthierarchy/src/CMakeLists.txt	(revision 443)
@@ -3,5 +3,5 @@
 # create a few variables to simplify life
 SET(SRC_FILES orxonox/orxonox.cc loader/LevelLoader.cc xml/xmlParser.cc orxonox/core/IdentifierList.cc orxonox/core/Identifier.cc orxonox/core/MetaObjectList.cc orxonox/core/Factory.cc orxonox/core/OrxonoxClass.cc orxonox/core/ConfigValueContainer.cc orxonox/objects/BaseObject.cc orxonox/objects/test1.cc orxonox/objects/test2.cc orxonox/objects/test3.cc)
-SET(INC_FILES loader/LevelLoader.h xml/xmlParser.h orxonox/core/IdentifierIncludes.h orxonox/core/Identifier.h orxonox/core/Factory.h orxonox/core/ClassFactory.h orxonox/core/IdentifierList.h orxonox/core/ObjectList.h orxonox/core/MetaObjectList.h orxonox/core/Iterator.h orxonox/core/OrxonoxClass.h orxonox/core/ConfigValueContainer.h orxonox/objects/BaseObject.h orxonox/objects/Test.h orxonox/objects/test1.h orxonox/objects/test2.h orxonox/objects/test3.h orxonox/objects/Tickable.h orxonox/objects/Timer.h)
+SET(INC_FILES loader/LevelLoader.h xml/xmlParser.h orxonox/core/CoreIncludes.h orxonox/core/Identifier.h orxonox/core/Factory.h orxonox/core/ClassFactory.h orxonox/core/IdentifierList.h orxonox/core/ObjectList.h orxonox/core/MetaObjectList.h orxonox/core/Iterator.h orxonox/core/OrxonoxClass.h orxonox/core/ConfigValueContainer.h orxonox/objects/BaseObject.h orxonox/objects/Test.h orxonox/objects/test1.h orxonox/objects/test2.h orxonox/objects/test3.h orxonox/objects/Tickable.h orxonox/objects/Timer.h)
 
 #Creates an executable
Index: code/branches/objecthierarchy/src/orxonox/core/CoreIncludes.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/core/CoreIncludes.h	(revision 443)
+++ code/branches/objecthierarchy/src/orxonox/core/CoreIncludes.h	(revision 443)
@@ -0,0 +1,82 @@
+/**
+    @file CoreIncludes.h
+    @brief Definition of macros for the class-hierarchy and the factory.
+
+    Every class needs the RegisterObject(class) macro in its constructor. If the class is an interface
+    or the BaseObject itself, it needs the macro RegisterRootObject(class) instead.
+
+    To allow the object being created through the factory, use the CreateFactory(class) macro outside
+    the of the class implementation, so it gets executed before main().
+*/
+
+// All needed header-files
+#include "Identifier.h"
+#include "Factory.h"
+#include "ClassFactory.h"
+#include "Iterator.h"
+#include "OrxonoxClass.h"
+#include "ConfigValueContainer.h"
+
+#include "OgreVector3.h"
+#include "OgreColourValue.h"
+
+namespace orxonox
+{
+    typedef Ogre::Vector3 Vector3;
+    typedef Ogre::ColourValue ColourValue;
+}
+
+// Intern macro, containing the common parts of RegisterObject and RegisterRootObject
+#define InternRegisterObject(ClassName, bRootClass) \
+    this->setIdentifier(ClassIdentifier<ClassName>::registerClass(this->getParents(), #ClassName, bRootClass)); \
+    if (Identifier::isCreatingHierarchy() && this->getParents()) \
+        this->getParents()->add(this->getIdentifier()); \
+    ClassIdentifier<ClassName>::addObject(this)
+
+// Intern macro, containing the specific part of RegisterRootObject
+#define InternRegisterRootObject(ClassName) \
+    if (Identifier::isCreatingHierarchy() && !this->getParents()) \
+        this->setParents(new IdentifierList()); \
+    InternRegisterObject(ClassName, true)
+
+// RegisterObject - with and without debug output
+#if HIERARCHY_VERBOSE
+#define RegisterObject(ClassName) \
+    std::cout << "*** Register Object: " << #ClassName << "\n"; \
+    InternRegisterObject(ClassName, false)
+#else
+#define RegisterObject(ClassName) \
+    InternRegisterObject(ClassName, false)
+#endif
+
+// RegisterRootObject - with and without debug output
+#if HIERARCHY_VERBOSE
+#define RegisterRootObject(ClassName) \
+    std::cout << "*** Register Root-Object: " << #ClassName << "\n"; \
+    InternRegisterRootObject(ClassName)
+#else
+#define RegisterRootObject(ClassName) \
+    InternRegisterRootObject(ClassName)
+#endif
+
+// Class(ClassName) returns the Identifier of the given class
+#define Class(ClassName) \
+    ClassIdentifier<ClassName>::getIdentifier()
+
+// Creates the entry in the Factory
+#define CreateFactory(ClassName) \
+    bool bCreated##ClassName##Factory = ClassFactory<ClassName>::create()
+
+// ID(StringOrInt) returns the Identifier with either a given name or a given NetworkID through the factory
+#define ID(StringOrInt) \
+    Factory::getIdentifier(StringOrInt)
+
+// bla
+#define SetConfigValue(varname, defvalue) \
+    ConfigValueContainer* container##varname = this->getIdentifier()->getConfigValueContainer(#varname); \
+    if (!container##varname) \
+    { \
+        container##varname = new ConfigValueContainer(this->getIdentifier()->getName(), #varname, defvalue); \
+        this->getIdentifier()->setConfigValueContainer(#varname, container##varname); \
+    } \
+    this->varname = container##varname->getValue(varname)
Index: code/branches/objecthierarchy/src/orxonox/core/IdentifierIncludes.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/core/IdentifierIncludes.h	(revision 435)
+++ 	(revision )
@@ -1,82 +1,0 @@
-/**
-    @file IDentifierIncludes.h
-    @brief Definition of macros for the class-hierarchy and the factory.
-
-    Every class needs the RegisterObject(class) macro in its constructor. If the class is an interface
-    or the BaseObject itself, it needs the macro RegisterRootObject(class) instead.
-
-    To allow the object being created through the factory, use the CreateFactory(class) macro outside
-    the of the class implementation, so it gets executed before main().
-*/
-
-// All needed header-files
-#include "Identifier.h"
-#include "Factory.h"
-#include "ClassFactory.h"
-#include "Iterator.h"
-#include "OrxonoxClass.h"
-#include "ConfigValueContainer.h"
-
-#include "OgreVector3.h"
-#include "OgreColourValue.h"
-
-namespace orxonox
-{
-    typedef Ogre::Vector3 Vector3;
-    typedef Ogre::ColourValue ColourValue;
-}
-
-// Intern macro, containing the common parts of RegisterObject and RegisterRootObject
-#define InternRegisterObject(ClassName, bRootClass) \
-    this->setIdentifier(ClassIdentifier<ClassName>::registerClass(this->getParents(), #ClassName, bRootClass)); \
-    if (Identifier::isCreatingHierarchy() && this->getParents()) \
-        this->getParents()->add(this->getIdentifier()); \
-    ClassIdentifier<ClassName>::addObject(this)
-
-// Intern macro, containing the specific part of RegisterRootObject
-#define InternRegisterRootObject(ClassName) \
-    if (Identifier::isCreatingHierarchy() && !this->getParents()) \
-        this->setParents(new IdentifierList()); \
-    InternRegisterObject(ClassName, true)
-
-// RegisterObject - with and without debug output
-#if HIERARCHY_VERBOSE
-#define RegisterObject(ClassName) \
-    std::cout << "*** Register Object: " << #ClassName << "\n"; \
-    InternRegisterObject(ClassName, false)
-#else
-#define RegisterObject(ClassName) \
-    InternRegisterObject(ClassName, false)
-#endif
-
-// RegisterRootObject - with and without debug output
-#if HIERARCHY_VERBOSE
-#define RegisterRootObject(ClassName) \
-    std::cout << "*** Register Root-Object: " << #ClassName << "\n"; \
-    InternRegisterRootObject(ClassName)
-#else
-#define RegisterRootObject(ClassName) \
-    InternRegisterRootObject(ClassName)
-#endif
-
-// Class(ClassName) returns the Identifier of the given class
-#define Class(ClassName) \
-    ClassIdentifier<ClassName>::getIdentifier()
-
-// Creates the entry in the Factory
-#define CreateFactory(ClassName) \
-    bool bCreated##ClassName##Factory = ClassFactory<ClassName>::create()
-
-// ID(StringOrInt) returns the Identifier with either a given name or a given NetworkID through the factory
-#define ID(StringOrInt) \
-    Factory::getIdentifier(StringOrInt)
-
-// bla
-#define SetConfigValue(varname, defvalue) \
-    ConfigValueContainer* container##varname = this->getIdentifier()->getConfigValueContainer(#varname); \
-    if (!container##varname) \
-    { \
-        container##varname = new ConfigValueContainer(this->getIdentifier()->getName(), #varname, defvalue); \
-        this->getIdentifier()->setConfigValueContainer(#varname, container##varname); \
-    } \
-    this->varname = container##varname->getValue(varname)
Index: code/branches/objecthierarchy/src/orxonox/objects/BaseObject.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/BaseObject.h	(revision 435)
+++ code/branches/objecthierarchy/src/orxonox/objects/BaseObject.h	(revision 443)
@@ -2,5 +2,5 @@
 #define _BaseObject_H__
 
-#include "../core/IdentifierIncludes.h"
+#include "../core/CoreIncludes.h"
 
 namespace orxonox
Index: code/branches/objecthierarchy/src/orxonox/objects/Test.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/Test.h	(revision 435)
+++ code/branches/objecthierarchy/src/orxonox/objects/Test.h	(revision 443)
@@ -3,5 +3,5 @@
 
 #include "BaseObject.h"
-#include "../core/IdentifierIncludes.h"
+#include "../core/CoreIncludes.h"
 
 namespace orxonox
Index: code/branches/objecthierarchy/src/orxonox/objects/Tickable.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/Tickable.h	(revision 435)
+++ code/branches/objecthierarchy/src/orxonox/objects/Tickable.h	(revision 443)
@@ -2,5 +2,5 @@
 #define _Tickable_H__
 
-#include "../core/IdentifierIncludes.h"
+#include "../core/CoreIncludes.h"
 #include "OgreFrameListener.h"
 
Index: code/branches/objecthierarchy/src/orxonox/objects/Timer.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/Timer.h	(revision 435)
+++ code/branches/objecthierarchy/src/orxonox/objects/Timer.h	(revision 443)
@@ -2,5 +2,5 @@
 #define _Timer_H__
 
-#include "../core/IdentifierIncludes.h"
+#include "../core/CoreIncludes.h"
 #include "OgreFrameListener.h"
 
Index: code/branches/objecthierarchy/src/orxonox/orxonox.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/orxonox.cc	(revision 435)
+++ code/branches/objecthierarchy/src/orxonox/orxonox.cc	(revision 443)
@@ -42,5 +42,5 @@
 //#include "../loader/LevelLoader.h"
 
-#include "core/IdentifierIncludes.h"
+#include "core/CoreIncludes.h"
 #include "objects/Tickable.h"
 #include "objects/Timer.h"