Index: code/branches/FICN/src/audio/AudioManager.cc
===================================================================
--- code/branches/FICN/src/audio/AudioManager.cc	(revision 457)
+++ code/branches/FICN/src/audio/AudioManager.cc	(revision 458)
@@ -7,19 +7,16 @@
 	AudioManager::AudioManager()
 	{
-		ambientPath = "audio/ambient";
+    ambientPath = "audio/ambient";
 
- 		alutInit(NULL, 0);
-		
-	    
-
+    alutInit(NULL, 0);
 
 
 	}
-		
+
 	AudioManager::~AudioManager()
 	{
 		for (unsigned int i=0;i<=bgSounds.size();i++)
 		{
-			bgSounds[i].release();	
+			bgSounds[i].release();
 		}
 		alutExit();
@@ -46,18 +43,18 @@
 	{
 		std::cout << "Stopped playing background sound"<<std::endl;
-	}	
+	}
 
 	void AudioManager::ambientAdd(std::string file)
 	{
-    std::string path = ambientPath + "/" + file + ".ogg"; 
+    std::string path = ambientPath + "/" + file + ".ogg";
 		AudioStream tmp(path);
 		tmp.open();
 		if (tmp.isLoaded())
 		{
-			bgSounds.push_back(tmp);	
+			bgSounds.push_back(tmp);
 			std::cout << "Added background sound "<<file<<std::endl;
 		}
 	}
-	
+
 	void AudioManager::update()
 	{
@@ -77,12 +74,15 @@
 				if (!playing)
 				{
-					if (currentBgSound < bgSounds.size()-1)
-					{
-						currentBgSound++;
-					}
-					else
-					{
-						currentBgSound=0;
-					}
+// 					if (currentBgSound < bgSounds.size()-1)
+// 					{
+// 						currentBgSound++;
+// 					}
+// 					else
+// 					{
+// 						currentBgSound=0;
+// 					}
+          // switch to next sound in list/array
+          currentBgSound = ++currentBgSound % bgSounds.size();
+
 					if (!bgSounds[currentBgSound].isLoaded())
 					{
@@ -96,18 +96,18 @@
 		}
 	}
-	
+
 	void AudioManager::setPos(std::vector<float> newPosition)
 	{
-		
+
 	}
 
 	void AudioManager::setSpeed(std::vector<float> newSpeed)
 	{
-		
+
 	}
 
 	void AudioManager::setOri(std::vector<float> at, std::vector<float> up)
 	{
-		
+
 	}
 }
Index: code/branches/FICN/src/audio/CMakeLists.txt
===================================================================
--- code/branches/FICN/src/audio/CMakeLists.txt	(revision 457)
+++ code/branches/FICN/src/audio/CMakeLists.txt	(revision 458)
@@ -1,5 +1,5 @@
 PROJECT(Orxonox)
 
-SET(SRC_FILES 
+SET(SRC_FILES
 	AudioIncludes.h
 	AudioManager.cc
@@ -8,5 +8,5 @@
 	AudioStream.cc
 )
-SET(INC_FILES 
+SET(INC_FILES
 	AudioManager.h
 	AudioBuffer.h
@@ -15,4 +15,5 @@
 )
 
+INCLUDE_DIRECTORIES(..)
 
 ADD_LIBRARY(audio ${SRC_FILES} ${INC_FILES})
Index: code/branches/FICN/src/orxonox/orxonox.cc
===================================================================
--- code/branches/FICN/src/orxonox/orxonox.cc	(revision 457)
+++ code/branches/FICN/src/orxonox/orxonox.cc	(revision 458)
@@ -114,7 +114,7 @@
     bool frameStarted(const FrameEvent& evt)
     {
-    
+
     	auMan->update();
-    
+
       mKeyboard->capture();
       mMouse->capture();
@@ -202,5 +202,5 @@
         setupScene();
         setupInputSystem();
-        setupCEGUI();
+//         setupCEGUI();
         createFrameListener();
         startRenderLoop();
@@ -215,6 +215,6 @@
 //        delete mSystem;
 
-        delete mListener;
-        delete mRoot;
+//         delete mListener;
+//         delete mRoot;
       }
 
@@ -294,5 +294,5 @@
 
       string levelFile = "sp_level_moonstation.oxw";
-      loader::LevelLoader* loader = new loader::LevelLoader(levelFile);
+//       loader::LevelLoader* loader = new loader::LevelLoader(levelFile);
     }
 
@@ -359,8 +359,8 @@
       }
 
-      void setupCEGUI()
-      {
-        Ogre::SceneManager *mgr = mRoot->getSceneManager("Default SceneManager");
-        Ogre::RenderWindow *win = mRoot->getAutoCreatedWindow();
+//       void setupCEGUI()
+//       {
+//         Ogre::SceneManager *mgr = mRoot->getSceneManager("Default SceneManager");
+//         Ogre::RenderWindow *win = mRoot->getAutoCreatedWindow();
 
         // CEGUI setup
@@ -369,5 +369,5 @@
 
         // Other CEGUI setup here.
-      }
+//       }
 
 